package io.renren.modules.sys.controller;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;

import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.security.controller.AbstractController;
import io.renren.modules.sys.dto.ChannelsDTO;
import io.renren.modules.sys.entity.ChannelsEntity;
import io.renren.modules.sys.excel.ChannelsExcel;
import io.renren.modules.sys.service.ChannelsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import springfox.documentation.annotations.ApiIgnore;


/**
 * 投放渠道表
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-29
 */
@RestController
@RequestMapping("sys/channels")
@Api(tags="投放渠道表")
public class ChannelsController extends AbstractController{
    @Autowired
    private ChannelsService channelsService;
    
    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:channels:page")
    public Result<PageData<ChannelsDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<ChannelsDTO> page = channelsService.page(params);
        return new Result<PageData<ChannelsDTO>>().ok(page);
    }

    @GetMapping("list")
    @ApiOperation("列表")
    public Result<List<ChannelsDTO>> get(){
        List<ChannelsDTO> list = channelsService.list(new HashMap<>());

        return new Result<List<ChannelsDTO>>().ok(list);
    }
    
    @GetMapping("listAll")
    @ApiOperation("所有数据")
    public Result<List<ChannelsEntity>> listAll(){
        return new Result<List<ChannelsEntity>>().ok(channelsService.listAll());
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:channels:info")
    public Result<ChannelsDTO> get(@PathVariable("id") Long id){
        ChannelsDTO data = channelsService.get(id);
        data.setOperationIdList(data.getOperationIds().split(","));
        return new Result<ChannelsDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:channels:save")
    public Result save(@RequestBody ChannelsDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        String join = StringUtils.join(dto.getOperationIdList(), ",");
        dto.setOperationIds(join);
        
        channelsService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:channels:update")
    public Result update(@RequestBody ChannelsDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        dto.setUpdateBy(getUserId());
        dto.setUpdateTime(new Date());
        channelsService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:channels:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        ChannelsEntity entity = new ChannelsEntity();
        entity.setStatus(Constant.Status.DISABLE.getValue());
        entity.setUpdateBy(getUserId());
        entity.setDeleteTime(new Date());
        channelsService.update(entity, new UpdateWrapper<ChannelsEntity>().in("id", ids));
        //channelsService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:channels:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<ChannelsDTO> list = channelsService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, ChannelsExcel.class);
    }

}